do
  local _base_0 = {
    refresh = function(self, dungeon_name)
      if not self.initialized then
        self.current_dungeon = dungeon_name
        self.boss_room = 5 + 2
        self.current_room = 1
        self.initialized = true
        return print("dungeon [" .. self.current_dungeon .. "] initialized!")
      else
        self.current_room = self.current_room + 1
        return print("dungeon [" .. self.current_dungeon .. "] refreshed!")
      end
    end,
    wipe = function(self)
      self.current_dungeon = ""
      self.boss_room = -1
      self.current_room = 0
      self.initialized = false
      for k in pairs((self.rewards)) do
        self.rewards[k] = nil
      end
      return print("dungeon [" .. self.current_dungeon .. "] wiped!")
    end
  }
  _base_0.__index = _base_0
  local _class_0 = setmetatable({
    __init = function() end,
    __base = _base_0,
    __name = "DungeonManager"
  }, {
    __index = _base_0,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  local self = _class_0
  self.initialized = false
  self.rewards = { }
  DungeonManager = _class_0
end
