do
  local _parent_0 = Entity
  local _base_0 = {
    update = function(self, dt)
      self.y = self.y - self.vspd
      self.x = self.x + self.spread_amt
      if self.timer <= 0 then
        mad.object:remove(self)
      else
        self.timer = self.timer - 1
      end
      return _parent_0.update(self, self)
    end,
    draw = function(self)
      love.graphics.setColor(0, 0, 0)
      love.graphics.rectangle("fill", self.x, self.y, self.w, self.h)
      return _parent_0.draw(self, self)
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, x, y)
      self.x, self.y = x, y
      self.spread_mod = {
        -1,
        1
      }
      self.vspd = 9
      self.hsp = 4
      self.damage = PlayerManager.gun_damage
      self.bonus_damage = 1
      self.total_damage = self.damage + self.bonus_damage
      self.range = PlayerManager.gun_grip.range
      self.spread = PlayerManager.gun_barrel.spread
      self.spread_amt = math.random(0, self.spread) * self.spread_mod[math.random(1, 2)]
      self.timer = self.range * 30
      return _parent_0.__init(self, self, 32, 32, "bullet", col.bullet)
    end,
    __base = _base_0,
    __name = "Bullet",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Bullet = _class_0
end
