do
  local _parent_0 = Entity
  local _base_0 = {
    update = function(self, dt) end,
    draw = function(self)
      love.graphics.setColor(0, 0, 0)
      love.graphics.print("Dungeon cleared!", 32, 32)
      love.graphics.print("Dungeon rewards: ", 32 + 16, 64)
      for i = 1, #DungeonManager.rewards do
        love.graphics.print(DungeonManager.rewards[i].name, 32 + 32, i * 32 + 64)
      end
      return love.graphics.print("Press space to continue.", 32, #DungeonManager.rewards * 32 + 64 + 32)
    end,
    keypressed = function(self, key)
      if key == " " then
        mad.room:change("town_launchpad")
        return DungeonManager:wipe()
      end
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, x, y)
      self.x, self.y = x, y
      return _parent_0.__init(self, self, 1, 1, "dungeon_rewards_menu")
    end,
    __base = _base_0,
    __name = "DungeonRewardsMenu",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  DungeonRewardsMenu = _class_0
end
