do
  local _parent_0 = Entity
  local _base_0 = {
    update = function(self, dt)
      if room == "dungeon_rewards" or room == "main_menu" then
        self.disabled = true
      else
        self.disabled = false
      end
      if self.disabled == true then
        self.show = false
      end
    end,
    draw = function(self)
      if self.show then
        love.graphics.setColor(0, 0, 0)
        love.graphics.print("Current gun: " .. PlayerManager.gun_name, 32, 32)
        if DungeonManager.initialized == true then
          love.graphics.print("Dungeon rewards: ", 32, 64)
          for i = 1, #DungeonManager.rewards do
            love.graphics.print(DungeonManager.rewards[i].name, 32 + 16, 32 * i + 64)
          end
        end
        love.graphics.print("Player Inventory", 300, 64)
        for i = 1, #PlayerManager.inventory do
          love.graphics.print(PlayerManager.inventory[i].name .. " " .. "x" .. PlayerManager.inventory[i].quantity, 300, 32 * i + 64)
        end
      end
    end,
    keypressed = function(self, key)
      if key == "p" and self.disabled == false then
        self.show = not self.show
      end
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, x, y)
      self.x, self.y = x, y
      self.show = false
      self.persistent = true
      self.disabled = false
      self.z = -1000000000
      return _parent_0.__init(self, self, 1, 1, "pause_menu")
    end,
    __base = _base_0,
    __name = "PauseMenu",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  PauseMenu = _class_0
end
